/*
 * main.c
 */
#include "copyright.h"

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <signal.h>
#include <setjmp.h>
#include <pwd.h>
#ifdef hpux
#include <time.h>
#else hpux
#include <sys/time.h>
#endif hpux
#ifndef hpux
#include <sys/wait.h>
#endif hpux
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

jmp_buf env;

main(argc, argv)
int argc;
char **argv;
{
    int intrupt();
    int team, s_type;
    int pno;
    char *host = NULL;
    int usage = 0;
    int err = 0;
    char *name, *ptr, *cp, *rindex();
    char buf[80];
    struct passwd *pwent, *getpwuid();
    int reaper();
    int passive=0;
    char *defaultsFile=NULL;

    name = *argv++;
    argc--;
    if ((ptr = rindex(name, '/')) != NULL)
	name = ptr + 1;
    while (*argv) {
	if (**argv == '-')
	    ++*argv;
	else
	    break;

	argc--;
	ptr = *argv++;
	while (*ptr) {
	    switch (*ptr) {
	    case 'u': usage++; break;
	    case 's': 
		if (*argv) {
		    xtrekPort=atoi(*argv); 
		    passive=1; 
		    argv++; 
		    argc--; 
		}
		break;
	    case 'p':
		if (*argv) {
		    xtrekPort=atoi(*argv);
		    argv++;
		    argc--;
		} 
		break;
	    case 'd':
		host = *argv;
		argc--;
		argv++;
		break;
	    case 'h':
		serverName = *argv;
		argc--;
		argv++;
		break;
	    case 'r':
		defaultsFile = *argv;
		argv++;
		argc--;
		break;
	    default: 
		fprintf(stderr, "%s: unknown option '%c'\n", name, *ptr);
		err++;
		break;
	    }
	    ptr++;
	}
    }
    initDefaults(defaultsFile);
    if (usage || err) {
	printUsage(name);
	exit(err);
    }
    /* compatability */
    if (argc > 0)
	host = argv[0];
    srandom(getpid() * time((long *) 0));
    /* this creates the necessary x windows for the game */
    newwin(host, name);
    /* open memory...? */
    openmem();

    if (!passive) {
	callServer(xtrekPort, serverName);
    } else {
	connectToServer(xtrekPort);
    }

    findslot();

    lastm = mctl->mc_current;
    mapAll();
    signal(SIGINT, SIG_IGN);
    (void) signal(SIGCHLD, reaper);

    /* Get login name */
    if ((pwent = getpwuid(getuid())) != NULL)
	(void) strncpy(login, pwent->pw_name, sizeof(login));
    else
	(void) strncpy(login, "Bozo", sizeof(login));
    login[sizeof(login) - 1] = '\0';

    if ((cp = getdefault("name")) != 0)
	(void) strncpy(pseudo, cp, sizeof(pseudo));
    else
	(void) strncpy(pseudo, login, sizeof(pseudo));
    pseudo[sizeof(pseudo) - 1] = '\0';

    getname(pseudo);
    loggedIn=1;

    showShields = booleanDefault("showshields", showShields);
    showStats = booleanDefault("showstats", showStats);
    keeppeace = booleanDefault("keeppeace", keeppeace);
    reportKills = booleanDefault("reportkills", reportKills);
    msgBeep = booleanDefault("msgbeep", msgBeep);	/* ATM - msg beep */

    initkeymap();
    sendOptionsPacket();

    /* Set p_hostile to hostile, so if keeppeace is on, the guy starts off
       hating everyone (like a good fighter should) */
    me->p_hostile = (FED|ROM|KLI|ORI);

    sprintf(buf,
      "Maximum:      %2d  %3d %3d               %3d   %6d   %3d   %3d",
      0, 0, 0, 0, 0, 0, 0);
    W_WriteText(tstatw,50,27,textColor,buf,strlen(buf),W_RegularFont);
    me->p_planets=0;
    me->p_genoplanets=0;
    me->p_armsbomb=0;
    me->p_genoarmsbomb=0;
    /* Set up a reasonable default */
    me->p_whydead=KQUIT;
    me->p_team=ALLTEAM;
    s_type = CRUISER;
    setjmp(env);		/* Reentry point of game */
    /* give the player the motd and find out which team he wants */
    entrywindow(&team, &s_type);
    if (team == -1) {
	W_DestroyWindow(w);
	sendByeReq();
	sleep(1);
	printf("OK, bye!\n");
	exit(0);
    }
    getship(myship, s_type);
    redrawall = 1;
    enter();
    calibrate_stats();
    W_ClearWindow(w);
    /*
    for (i = 0; i < NSIG; i++) {
	signal(i, SIG_IGN);
    }
    */

    me->p_status = PALIVE;			/* Put player in game */
    me->p_ghostbuster = 0;

    if (showStats)			/* Default showstats are on. */
	W_MapWindow(statwin);

    /* Get input until the player quits or dies */
    input();
}

printUsage(prog)
	char	*prog;
{
	printf("Usage: %s [-r defaultfile] [-s socketnum] [-h hostname] [-d display-name]\n    [-p connect socketnum]\n",prog);
}

reaper()
{
#ifdef hpux
    wait((int *) 0);
#else hpux
    while (wait3((union wait *) 0, WNOHANG, NULL) > 0)
	;
#endif hpux
}
