/*
 * newwin.c
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <signal.h>
#include <sys/types.h>
#ifdef hpux
#include <time.h>
#else hpux
#include <sys/time.h>
#endif hpux
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "bitmaps.h"
#include "oldbitmaps.h"
#include "packets.h"
char *malloc();
static int line=0;
static int maxline=0;

#define SIZEOF(a)	(sizeof (a) / sizeof (*(a)))

#define BOXSIDE		(WINSIDE / 5)
#define TILESIDE	16
#define MESSAGESIZE	20
#define STATSIZE	(MESSAGESIZE * 2 + BORDER)
#define YOFF		0

#define stipple_width 16
#define stipple_height 16
static char stipple_bits[] = {
   0x01, 0x01, 0x02, 0x02, 0x04, 0x04, 0x08, 0x08,
   0x10, 0x10, 0x20, 0x20, 0x40, 0x40, 0x80, 0x80,
   0x01, 0x01, 0x02, 0x02, 0x04, 0x04, 0x08, 0x08,
   0x10, 0x10, 0x20, 0x20, 0x40, 0x40, 0x80, 0x80};

newwin(hostmon, progname)
char *hostmon, *progname;
{
    int i;

    W_Initialize(hostmon);

    baseWin = W_MakeWindow("netrek",0,YOFF,WINSIDE*2+1*BORDER,
	WINSIDE+2*BORDER+2*MESSAGESIZE,NULL,BORDER,gColor);
    iconWin = W_MakeWindow("netrek_icon",0, 0, icon_width, icon_height, NULL,
	BORDER, gColor);
    W_SetIconWindow(baseWin, iconWin);
    w = W_MakeWindow("local",-BORDER, -BORDER, WINSIDE, WINSIDE, baseWin, 
	BORDER, foreColor);
    mapw = W_MakeWindow("map", WINSIDE, -BORDER, WINSIDE, WINSIDE, baseWin, 
	BORDER, foreColor);
    tstatw = W_MakeWindow("tstat", -BORDER,WINSIDE,WINSIDE,STATSIZE,baseWin,
	BORDER, foreColor);
    warnw = W_MakeWindow("warn", WINSIDE, WINSIDE, WINSIDE, MESSAGESIZE, 
	baseWin, BORDER, foreColor);
    messagew = W_MakeWindow("message", WINSIDE, WINSIDE+BORDER+MESSAGESIZE,
	WINSIDE, MESSAGESIZE, baseWin, BORDER, foreColor);
    planetw = W_MakeTextWindow("planet",10,10,53,MAXPLANETS+3,w,2);
    rankw = W_MakeTextWindow("rank",50,300,65,NUMRANKS+8,w,2);
    playerw = W_MakeTextWindow("player",0,YOFF+WINSIDE+2*BORDER+2*MESSAGESIZE,
	83, MAXPLAYER+3, NULL, 2);
    helpWin = W_MakeTextWindow("help",0,YOFF+WINSIDE+2*BORDER+2*MESSAGESIZE,
	160, 13, NULL, BORDER);
    messwa = W_MakeScrollingWindow("review_all", WINSIDE + BORDER,
	YOFF + WINSIDE + 3 * BORDER + 2 * MESSAGESIZE, 80, 10, 0, BORDER);
    messwt = W_MakeScrollingWindow("review_team", WINSIDE + BORDER,
	YOFF + WINSIDE + 4 * BORDER + 2 * MESSAGESIZE + 10*W_Textheight + 8,
	80, 5, 0, BORDER);
    messwi = W_MakeScrollingWindow("review_your",WINSIDE + BORDER,
	YOFF + WINSIDE + 5 * BORDER + 2 * MESSAGESIZE + 15*W_Textheight + 16,
	80, 4, 0, BORDER);
    messwk = W_MakeScrollingWindow("review_kill", WINSIDE + BORDER,
	YOFF + WINSIDE + 6 * BORDER + 2 * MESSAGESIZE + 19*W_Textheight + 24,
	80, 6, 0, BORDER);
    reviewWin = W_MakeScrollingWindow("review", WINSIDE+BORDER,
	YOFF + WINSIDE +3*BORDER+2*MESSAGESIZE,80,20,0,BORDER);
    for (i = 0; i < 4; i++) {
        teamWin[i] = W_MakeWindow(teamshort[1<<i], i * BOXSIDE, 400, 
	    BOXSIDE, BOXSIDE, w, 1, foreColor);
    }
    qwin = W_MakeWindow("quit", 4 * BOXSIDE, 400, BOXSIDE, BOXSIDE, w, 1, 
	foreColor);
    statwin = W_MakeWindow("stats", 422, 13, 160, 95, NULL, 5, foreColor);
    W_DefineCursor(baseWin, 16, 16, cross_bits, crossmask_bits, 7, 7);
    W_DefineCursor(messwa, 16, 16, cross_bits, crossmask_bits, 7, 7);
    W_DefineCursor(messwt, 16, 16, cross_bits, crossmask_bits, 7, 7);
    W_DefineCursor(messwi, 16, 16, cross_bits, crossmask_bits, 7, 7);
    W_DefineCursor(helpWin, 16, 16, cross_bits, crossmask_bits, 7, 7);
    W_DefineCursor(playerw, 16, 16, cross_bits, crossmask_bits, 7, 7);
    W_DefineCursor(statwin, 16, 16, cross_bits, crossmask_bits, 7, 7);

#define WARHEIGHT 2
#define WARWIDTH 20
#define WARBORDER 2

    war = W_MakeMenu("war", WINSIDE+10, -BORDER+10, WARWIDTH, 6, baseWin, 
	WARBORDER);

    getResources(progname);
    savebitmaps();
}

mapAll()
{
    initinput();
    W_MapWindow(mapw);
    W_MapWindow(tstatw);
    W_MapWindow(warnw);
    W_MapWindow(messagew);
    W_MapWindow(w);
    W_MapWindow(baseWin);
}

savebitmaps()
{
    register int i;
    for (i = 0; i < VIEWS; i++) { 
	fed_bitmaps[SCOUT][i] = 
	  W_StoreBitmap(fed_scout_width, fed_scout_height,
			fed_scout_bits[i], w);
	fed_bitmaps[DESTROYER][i] = 
	  W_StoreBitmap(fed_destroyer_width, fed_destroyer_height,
			fed_destroyer_bits[i], w);
	fed_bitmaps[CRUISER][i] = 
	  W_StoreBitmap(fed_cruiser_width, fed_cruiser_height,
			fed_cruiser_bits[i], w);
	fed_bitmaps[BATTLESHIP][i] = 
	  W_StoreBitmap(fed_battleship_width, fed_battleship_height,
			fed_battleship_bits[i], w);
	fed_bitmaps[ASSAULT][i] = 
	  W_StoreBitmap(fed_assault_width, fed_assault_height,
			fed_assault_bits[i], w);
	fed_bitmaps[STARBASE][i] = 
	  W_StoreBitmap(fed_starbase_width, fed_starbase_height,
			fed_starbase_bits[i], w);

 	kli_bitmaps[SCOUT][i] = 
	  W_StoreBitmap(kli_scout_width, kli_scout_height,
			kli_scout_bits[i], w);
 	kli_bitmaps[DESTROYER][i] = 
	  W_StoreBitmap(kli_destroyer_width, kli_destroyer_height,
			kli_destroyer_bits[i], w);
	kli_bitmaps[CRUISER][i] = 
	  W_StoreBitmap(kli_cruiser_width, kli_cruiser_height,
			kli_cruiser_bits[i], w);
	kli_bitmaps[BATTLESHIP][i] = 
	  W_StoreBitmap(kli_battleship_width, kli_battleship_height,
			kli_battleship_bits[i], w);
 	kli_bitmaps[ASSAULT][i] = 
	  W_StoreBitmap(kli_assault_width, kli_assault_height,
			kli_assault_bits[i], w);
 	kli_bitmaps[STARBASE][i] = 
	  W_StoreBitmap(kli_starbase_width, kli_starbase_height,
			kli_starbase_bits[i], w);

	rom_bitmaps[SCOUT][i] = 
	  W_StoreBitmap(rom_scout_width, rom_scout_height,
			rom_scout_bits[i], w);
	rom_bitmaps[DESTROYER][i] = 
	  W_StoreBitmap(rom_destroyer_width, rom_destroyer_height,
			rom_destroyer_bits[i], w);
	rom_bitmaps[CRUISER][i] = 
	  W_StoreBitmap(rom_cruiser_width, rom_cruiser_height,
			rom_cruiser_bits[i], w);
	rom_bitmaps[BATTLESHIP][i] = 
	  W_StoreBitmap(rom_battleship_width, rom_battleship_height,
			rom_battleship_bits[i], w);
	rom_bitmaps[ASSAULT][i] = 
	  W_StoreBitmap(rom_assault_width, rom_assault_height,
			rom_assault_bits[i], w);
	rom_bitmaps[STARBASE][i] = 
	  W_StoreBitmap(rom_starbase_width, rom_starbase_height,
			rom_starbase_bits[i], w);

	ori_bitmaps[SCOUT][i] = 
	  W_StoreBitmap(ori_scout_width, ori_scout_height,
			ori_scout_bits[i], w);
	ori_bitmaps[DESTROYER][i] = 
	  W_StoreBitmap(ori_destroyer_width, ori_destroyer_height,
			ori_destroyer_bits[i], w);
	ori_bitmaps[CRUISER][i] = 
	  W_StoreBitmap(ori_cruiser_width, ori_cruiser_height,
			ori_cruiser_bits[i], w); 
	ori_bitmaps[BATTLESHIP][i] = 
	  W_StoreBitmap(ori_battleship_width, ori_battleship_height,
			ori_battleship_bits[i], w);
	ori_bitmaps[ASSAULT][i] = 
	  W_StoreBitmap(ori_assault_width, ori_assault_height,
			ori_assault_bits[i], w);
	ori_bitmaps[STARBASE][i] = 
	  W_StoreBitmap(ori_starbase_width, ori_starbase_height,
			ori_starbase_bits[i], w);

	fed_bitmaps[ATT][i] = kli_bitmaps[ATT][i] = rom_bitmaps[ATT][i] =
	    ori_bitmaps[ATT][i] =
	  W_StoreBitmap(att_width, att_height, att_bits[i], w);
    }
    clockpic=W_StoreBitmap(clock_width, clock_height, clock_bits,
	qwin);
    for (i=0; i<5; i++) {
	cloud[i] = W_StoreBitmap(cloud_width, cloud_height, cloud_bits[4-i],w);
	plasmacloud[i] = W_StoreBitmap(plasmacloud_width, 
	    plasmacloud_height, plasmacloud_bits[4-i],w);
    }
    etorp = W_StoreBitmap(etorp_width, etorp_height, etorp_bits,w);
    mtorp = W_StoreBitmap(mtorp_width, mtorp_height, mtorp_bits,w);
    eplasmatorp = 
      W_StoreBitmap(eplasmatorp_width, eplasmatorp_height, eplasmatorp_bits,w);
    mplasmatorp = 
      W_StoreBitmap(mplasmatorp_width, mplasmatorp_height, mplasmatorp_bits,w);
    bplanets[0] = W_StoreBitmap(planet_width, planet_height, indplanet_bits,w);
    bplanets[1] = W_StoreBitmap(planet_width, planet_height, fedplanet_bits,w);
    bplanets[2] = W_StoreBitmap(planet_width, planet_height, romplanet_bits,w);
    bplanets[3] = W_StoreBitmap(planet_width, planet_height, kliplanet_bits,w);
    bplanets[4] = W_StoreBitmap(planet_width, planet_height, oriplanet_bits,w);
    bplanets[5] = W_StoreBitmap(planet_width, planet_height, planet_bits,w);
    mbplanets[0] = W_StoreBitmap(mplanet_width, mplanet_height, indmplanet_bits,mapw);
    mbplanets[1] = W_StoreBitmap(mplanet_width, mplanet_height, fedmplanet_bits,mapw);
    mbplanets[2] = W_StoreBitmap(mplanet_width, mplanet_height, rommplanet_bits,mapw);
    mbplanets[3] = W_StoreBitmap(mplanet_width, mplanet_height, klimplanet_bits,mapw);
    mbplanets[4] = W_StoreBitmap(mplanet_width, mplanet_height, orimplanet_bits,mapw);
    mbplanets[5] = W_StoreBitmap(mplanet_width, mplanet_height, mplanet_bits,mapw);
    bplanets2[0] = bplanets[0];
    mbplanets2[0] = mbplanets[0];
    bplanets2[1] = W_StoreBitmap(planet_width, planet_height, planet001_bits,w);
    bplanets2[2] = W_StoreBitmap(planet_width, planet_height, planet010_bits,w);
    bplanets2[3] = W_StoreBitmap(planet_width, planet_height, planet011_bits,w);
    bplanets2[4] = W_StoreBitmap(planet_width, planet_height, planet100_bits,w);
    bplanets2[5] = W_StoreBitmap(planet_width, planet_height, planet101_bits,w);
    bplanets2[6] = W_StoreBitmap(planet_width, planet_height, planet110_bits,w);
    bplanets2[7] = W_StoreBitmap(planet_width, planet_height, planet111_bits,w);
    mbplanets2[1]=W_StoreBitmap(mplanet_width,mplanet_height,mplanet001_bits,mapw);
    mbplanets2[2]=W_StoreBitmap(mplanet_width,mplanet_height,mplanet010_bits,mapw);
    mbplanets2[3]=W_StoreBitmap(mplanet_width,mplanet_height,mplanet011_bits,mapw);
    mbplanets2[4]=W_StoreBitmap(mplanet_width,mplanet_height,mplanet100_bits,mapw);
    mbplanets2[5]=W_StoreBitmap(mplanet_width,mplanet_height,mplanet101_bits,mapw);
    mbplanets2[6]=W_StoreBitmap(mplanet_width,mplanet_height,mplanet110_bits,mapw);
    mbplanets2[7]=W_StoreBitmap(mplanet_width,mplanet_height,mplanet111_bits,mapw);
    for (i = 0; i < EX_FRAMES; i++) {
	expview[i]=W_StoreBitmap(ex_width, ex_height, ex_bits[i],w);
    }
    for (i = 0; i < SBEXPVIEWS; i++) {
	sbexpview[i]=W_StoreBitmap(sbexp_width, sbexp_height, sbexp_bits[i],w);
    }
    shield = W_StoreBitmap(shield_width, shield_height, shield_bits,w);
    cloakicon = W_StoreBitmap(cloak_width, cloak_height, cloak_bits,w);
    icon = W_StoreBitmap(icon_width, icon_height, icon_bits, iconWin);
}

/* This routine throws up an entry window for the player. */

entrywindow(team, s_type) 
int *team, *s_type;
{
    int typeok=0, i=0;
    long startTime;
    W_Event event;
    int lastplayercount[4];
    int okayMask, lastOkayMask;
    int resetting=0;
    int tiled=0;
    long lasttime = -1;
    int spareTime=240;	/* Allow them an extra 240 seconds, as long */
			/* as they are active */

    /* The following allows quick choosing of teams */

    lastOkayMask = okayMask = tournMask;

    for (i = 0; i < 4; i++) {
	if (okayMask & (1 << i)) {
	    tiled=0;
	} else {
	    tiled=1;
        }

	if (tiled) {
	    W_TileWindow(teamWin[i],stipple);
	} else {
	    W_UnTileWindow(teamWin[i]);
	}
        W_MapWindow(teamWin[i]);
        lastplayercount[i] = -1;        /* force redraw first time through */
    }
    W_MapWindow(qwin);

    *team = -1;
    startTime = time(0);
    if (me->p_whydead != KWINNER && me->p_whydead != KGENOCIDE) showMotd();
    do {
	    while (!W_EventsPending()) {
		int		mask, elapsed;
		struct timeval	tv;

		readFromServer();
		me->p_ghostbuster = 0;
		tv.tv_sec = 1;
		tv.tv_usec = 0;
		/* If we don't have a socket, we go nuts polling. */
		if (W_Socket() != -1) {
		    mask = 1 << W_Socket();
		    select(32, &mask, 0, 0, &tv);
		}
		elapsed = time(0) - startTime;
		if (elapsed > AUTOQUIT) {
		    printf("Auto-Quit.\n");
		    *team = 4;
		    break;
		}
		if (lasttime != time(0)) {
		    showTimeLeft(elapsed, AUTOQUIT);
		    lasttime=time(0);
		}

		okayMask = tournMask;

                for (i = 0; i < 4; i++) {
                    if ((okayMask ^ lastOkayMask) & (1 << i)) {
                        if (okayMask & (1 << i)) {
			    W_UnTileWindow(teamWin[i]);
                        } else {
			    W_TileWindow(teamWin[i], stipple);
                        }
                        lastplayercount[i] = -1;        /* force update */
                    }
                    redrawTeam(teamWin[i], i, &lastplayercount[i]);
                }
                lastOkayMask = okayMask;
	    }
	    if (*team == 4)
		break;
	    
	    if (time(0) - startTime <= spareTime) {
		spareTime -= time(0) - startTime;
		startTime = time(0);
	    } else {
		startTime += spareTime;
		spareTime = 0;
	    }
	    if (!W_EventsPending()) continue;
	    W_NextEvent(&event);
	    typeok=1;
	    switch ((int) event.type) {
	    case W_EV_KEY:
		switch (event.key) {
		case 's': *s_type = SCOUT;
			  break;
		case 'd': *s_type = DESTROYER;
			  break;
		case 'c': *s_type = CRUISER;
			  break;
		case 'b': *s_type = BATTLESHIP;
			  break;
		case 'a': *s_type = ASSAULT;
			  break;
		case 'o': *s_type = STARBASE;
			  break;		/* FIX */
		case '*': *s_type = ATT;
			  break;
		default:  typeok = 0;
			  break;
		}
		if (event.Window == w) {
		    switch(event.key) {
		    case 'y':
			if (resetting) {
			    sendResetStatsReq('Y');
			    warning("OK, your stats have been reset.");
			    resetting=0;
			}
			break;
		    case 'n':
			if (resetting) {
			    warning("I didn't think so.");
			    resetting=0;
			}
			break;
		    case 'R':
			warning("Are you sure you want to reset your stats?");
			resetting=1;
			break;
		    case 'f':		/* Scroll motd forward */
			line=line+28;
			if (line>maxline) {
			    line=line-28;
			    break;
			}
			showMotd();
			break;
		    case 'b':		/* Scroll motd backward */
			if (line==0) break;
			line=line-28;
			if (line<0) line=0;
			showMotd();
			break;
		    }
		}
		/* No break, we just fall through */
	    case W_EV_BUTTON:
		if (typeok == 0) break;
		for (i = 0; i < 4; i++)
		    if (event.Window == teamWin[i]) {
			*team = i;
			break;
		    }
		if (event.Window == qwin){
		    *team = 4;
		    break;
		}
		if (*team!=-1 && !teamRequest(*team, *s_type)) {
		    *team= -1;
		}
		break;
	    case W_EV_EXPOSE:
		for (i = 0; i < 4; i++)
		    if (event.Window == teamWin[i]) {
			lastplayercount[i] = -1;    /* force update */
			redrawTeam(teamWin[i], i, &lastplayercount[i]);
			break;
		    }
		if (event.Window == qwin)
		    redrawQuit();
		else if (event.Window == tstatw)
		    redrawTstats();
		else if (event.Window == iconWin)
		    drawIcon();
		else if (event.Window == w)
		    showMotd();
		else if (event.Window == helpWin)
		    fillhelp();
		else if (event.Window == playerw) 
		    playerlist();
		else if (event.Window == warnw) 
		    W_ClearWindow(warnw);
		else if (event.Window == messagew)
		    W_ClearWindow(messagew);
		break;
	    }
    } while (*team < 0);
    if (event.Window != qwin)
	warning("Welcome aboard Captain!");

    if (*team == 4) {
	*team = -1;
    }
				
    for (i = 0; i < 4; i++)
        W_UnmapWindow(teamWin[i]);
    W_UnmapWindow(qwin);
}

/* Attempt to pick specified team & ship */
teamRequest(team, ship) 
int team,ship;
{
    int lastTime;

    pickOk= -1;
    sendTeamReq(team,ship);
    lastTime=time(NULL);
    while (pickOk == -1) {
	if (lastTime+3 < time(NULL)) {
	    sendTeamReq(team,ship);
	}
	socketPause();
	readFromServer();
	if (isServerDead()) {
	    printf("Whoops!  We've been ghostbusted!\n");
	    printf("Pray for a miracle!\n");
	    connectToServer(nextSocket);
	    printf("Yea!  We've been resurrected!\n");
	    pickOk=0;
	    break;
	}
    }
    return(pickOk);
}

numShips(owner)
{
	int		i, num = 0;
	struct player	*p;

	for (i = 0, p = players; i < MAXPLAYER; i++, p++)
		if (p->p_status == PALIVE && p->p_team == owner)
			num++;
	return (num);
}

realNumShips(owner)
{
	int		i, num = 0;
	struct player	*p;

	for (i = 0, p = players; i < MAXPLAYER; i++, p++)
		if (p->p_status != PFREE && 
		    p->p_team == owner)
			num++;
	return (num);
}

deadTeam(owner)
int owner;
/* The team is dead if it has no planets and cannot coup it's home planet */
{
    int i,num=0;
    struct planet *p;

    if (planets[remap[owner]*10-10].pl_couptime == 0) return(0);
    for (i=0, p=planets; i<MAXPLANETS; i++,p++) {
	if (p->pl_owner & owner) {
	    num++;
	}
    }
    if (num!=0) return(0);
    return(1);
}

static char	*AUTHOR[] = {
    "",
    "---  XtrekII Release Version 6.1 ---",
    "",
    "By Chris Guthrie, Ed James,",
    "Scott Silvey (scott@scam), and Kevin Smith (ksmith@miro)"
};

checkBold(line)
/* Determine if that line should be highlighted on sign-on screen */
/* Which is done when it is the players own score being displayed */
char *line;
{
    char *s, *t;
    int i;
    int end=0;

    if (strlen(line) < 60) return(0);
    s = line+4;
    t = me->p_name;

    for (i=0; i<16; i++) {
	if (!end) {
	    if (*t == '\0') end=1;
	    else if (*t != *s) return(0);
	}
	if (end) {
	    if (*s != ' ') return(0);
	}
	s++;
	t++;
    }
    return(1);
}

struct list {
    char bold;
    struct list *next;
    char *data;
};
static struct list *motddata = NULL;

showMotd()
{
    FILE *fopen();
    int	i, length, top, center;
    struct list *data;
    static int first=1;
    int count;

    W_ClearWindow(w);
    for (i = 0; i < SIZEOF(AUTHOR); i++) {
	length = strlen(AUTHOR[i]);
	center = WINSIDE / 2 - (length * W_Textwidth) / 2;
	W_WriteText(w, center, i*W_Textheight, textColor, AUTHOR[i], length,
	    W_RegularFont);
    }
    top = SIZEOF(AUTHOR) + 7;

    if (first) {
	first=0;
	data=motddata;
	while (data!=NULL) {
	    data->bold=checkBold(data->data);
	    data=data->next;
	}
    }

    data=motddata;
    for (i=0; i<line; i++) {
	if (data==NULL) {
	    line=0;
	    data=motddata;
	    break;
	}
	data=data->next;
    }
    count=28;	/* Magical # of lines to display */
    for (i=top; i<50; i++) {
	if (data==NULL) break;
	if (!strcmp(data->data, "\t@@@"))		/* ATM */
	    break;
	if (data->bold) {
	    W_WriteText(w, 20, i*W_Textheight, textColor, data->data,
		strlen(data->data), W_BoldFont);
	} else {
	    W_WriteText(w, 20, i*W_Textheight, textColor, data->data,
		strlen(data->data), W_RegularFont);
	}
	data=data->next;
	count--;
	if (count<=0) break;
    }

    showValues(data);
}

/*
 * ATM: show the current values of the .sysdef parameters.
 */
showValues(data)
struct list *data;
{
    int i;
    static char *msg = "OPTIONS SET WHEN YOU STARTED WERE:";

    /* try to find the start of the info */
    while (1) {
	if (data == NULL) return;
	if (!strcmp(data->data, STATUS_TOKEN))		/* ATM */
	    break;
	data = data->next;
    }
    data = data->next;

    W_WriteText(mapw, 20, 14*W_Textheight, textColor, msg,
	strlen(msg), W_RegularFont);
    for (i = 16; i < 50; i += 2) {
	if (data == NULL) break;
	W_WriteText(mapw, 20, i*W_Textheight, textColor, data->data,
	    strlen(data->data), W_RegularFont);
	data = data->next;
    }
}

newMotdLine(line)
char *line;
{
    static struct list **temp = &motddata;
    static int statmode = 0;			/* ATM */

    if (!statmode && !strcmp(line, STATUS_TOKEN))
	statmode = 1;
    if (!statmode) maxline++;			/* ATM - don't show on left */
    (*temp) = (struct list *) malloc(sizeof(struct list));
    (*temp)->next = NULL;
    (*temp)->data = malloc(strlen(line)+1);
    strcpy((*temp)->data, line);
    temp= &((*temp)->next);
}

getResources(prog)
char	*prog;
{
    getColorDefs(prog);
    getTiles();
}

getTiles()
{
    stipple = W_StoreBitmap(stipple_width, stipple_height, stipple_bits, w);
}

redrawTeam(win, teamNo, lastnum)
W_Window win;
int *lastnum;
{
    char buf[BUFSIZ];
    static char *teams[] = { "Federation", "Romulan", "Klingon", "Orion" };
    int num = numShips(1 << teamNo);

    /* Only redraw if number of players has changed */
    if (*lastnum == num)
        return;

    W_ClearWindow(win);
    W_WriteText(win, 5, 5, shipCol[teamNo + 1], teams[teamNo], 
	strlen(teams[teamNo]), W_RegularFont);
    (void) sprintf(buf, "%d", num);
    W_MaskText(win, 5, 46, shipCol[teamNo + 1], buf, strlen(buf), 
	W_BigFont);
    *lastnum = num;
}

redrawQuit()
{
    W_WriteText(qwin, 5, 5, textColor, "Quit xtrek", 10, W_RegularFont);
}

char *help_message[] = {
    "0-9   Set speed",
    ")     speed = 10",
    "!     speed = 11",
    "@     speed = 12",
    "k     Set course",
    "p     Fire phaser",
    "t     Fire photon torpedo",
    "f     Fire plasma torpedo",
    "d     detonate enemy torps",
    "D     detonate own torps",
    "L     List players",
    "P     List planets",
    "S     Status graph toggle",
    "M     Turn on/off map window updating",
    "]     Put up shields",
    "[     Put down shields",
    "u     Shield toggle",
    "i     Info on player/planet",
    "I     Extended info on player",
    "b     Bomb planet",
    "z     Beam up armies",
    "x     Beam down armies",
    "T     Toggle tractor beam",
    "y     Toggle pressor beam",
    "R     Enter repair mode",
    "o     Orbit planet or dock to outpost",
    "e     Docking permission toggle",
    "r     Change vessels (ship type)",
    "Q     Quit",
    "?     Message window toggle",
    "c     Cloaking device toggle",
    "C     Coup a planet",
    "l     Lock on to player/planet",
    "h     Help window toggle",
    "w     War declarations window",
    "N     Planet names toggle",
    "V     Rotate local planet display",
    "B     Rotate galactic planet display",
    "E     Send distress call",
    "*     Send in practice robot",
    "U     Show rankings window",
    0,
};

#define MAXHELP 40

fillhelp()
{
    register int i = 0, row, column;

    W_ClearWindow(helpWin);
    for (column = 0; column < 4; column++) {
	for (row = 1; row < 12; row++) {
	    if (help_message[i] == 0)
		break;
	    else {
		W_WriteText(helpWin, MAXHELP * column, row, textColor,
		    help_message[i], strlen(help_message[i]), W_RegularFont);
		i++;
	    }
	}
	if (help_message[i] == 0)
	    break;
    }
}

drawIcon()
{
    W_WriteBitmap(0, 0, icon, W_White);
}

#define CLOCK_WID	(BOXSIDE * 9 / 10)
#define CLOCK_HEI	(BOXSIDE * 2 / 3)
#define CLOCK_BDR	0
#define CLOCK_X		(BOXSIDE / 2 - CLOCK_WID / 2)
#define CLOCK_Y		(BOXSIDE / 2 - CLOCK_HEI / 2)

#define PI		3.141592654

showTimeLeft(time, max)
int time, max;
{
    char	buf[BUFSIZ], *cp;
    int	cx, cy, ex, ey, tx, ty;

    if ((max - time) < 10 && time & 1) {
	W_Beep();
    }
    W_ClearArea(qwin, CLOCK_X, CLOCK_Y, CLOCK_WID, CLOCK_HEI, backColor);

    cx = CLOCK_X + CLOCK_WID / 2;
    cy = CLOCK_Y + (CLOCK_HEI - W_Textheight) / 2;
    ex = cx - clock_width / 2;
    ey = cy - clock_height / 2;
    W_WriteBitmap(ex, ey, clockpic, foreColor);

    ex = cx - clock_width * sin(2 * PI * time / max) / 2;
    ey = cy - clock_height * cos(2 * PI * time / max) / 2;
    W_MakeLine(qwin, cx, cy, ex, ey, foreColor);

    sprintf(buf, "%d", max - time);
    tx = cx - W_Textwidth * strlen(buf) / 2;
    ty = cy - W_Textheight / 2;
    W_WriteText(qwin, tx, ty, textColor, buf, strlen(buf), W_RegularFont);

    cp = "Auto Quit";
    tx = CLOCK_X + cx - W_Textwidth * strlen(cp) / 2;
    ty = CLOCK_Y + CLOCK_HEI - W_Textheight;
    W_WriteText(qwin, tx, ty, textColor, cp, strlen(cp), W_RegularFont);
}


do_refit(type)
    int type;
{	
    sendRefitReq(type);
    localflags &= ~PFREFIT;
}
