/*
 * input.c
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <errno.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

static int sendflag=0;

setflag()
{
#ifdef NOTSIGSET
    struct itimerval	udt;

    signal(SIGALRM, SIG_IGN);		/* ATM: mask signals */
#endif
    sendflag=1;

#ifdef NOTSIGSET
    udt.it_interval.tv_sec = 1;
    udt.it_interval.tv_usec = 0;
    udt.it_value.tv_sec = 0;
    udt.it_value.tv_usec = timerDelay;
    signal(SIGALRM, setflag);		/* ATM: reset signal handler */
    setitimer(ITIMER_REAL, &udt, 0);	/* ATM: reload timer manually */
#endif
}

input()
{
    int fd, nchar;
    struct itimerval	udt;
    struct timeval timeout;
    int readfds;

    udt.it_interval.tv_sec = 0;
    udt.it_interval.tv_usec = timerDelay;	/* ATM: was timerDelay */
    udt.it_value.tv_sec = 0;
    udt.it_value.tv_usec = timerDelay;
    sigset(SIGALRM, setflag);			/* ATM: was after setitim() */
    setitimer(ITIMER_REAL, &udt, 0);

    /* Idea:  read from client often, send to client not so often */
    while (1) {
	if (isClientDead()) {
	    int i;
	    char buf[80];

	    if (noressurect) exit(0);
	    udt.it_interval.tv_sec = 0;
	    udt.it_interval.tv_usec = 0;
	    udt.it_value.tv_sec = 0;
	    udt.it_value.tv_usec = 0;
	    sigset(SIGALRM, SIG_IGN);		/* ATM: was after setitim() */
	    setitimer(ITIMER_REAL, &udt, 0);
	    printf("Ack!  The client went away!\n");
	    printf("I will attempt to resurrect him!\n");
	    /* For next two minutes, we try to restore connection */
	    shutdown(sock, 2);
	    sock= -1;
	    for (i=0;; i++) {
		me->p_ghostbuster = 0;
		sleep(5);
		if (connectToClient(host, nextSocket)) break;
		if (i==1) {		/* ATM: was 23 */
		    printf("Oh well, maybe I'm getting rusty!\n");
		    exit(0);
		}
	    }
	    udt.it_interval.tv_sec = 0;
	    udt.it_interval.tv_usec = timerDelay;     /* ATM: was timerDelay */
	    udt.it_value.tv_sec = 0;
	    udt.it_value.tv_usec = timerDelay;
	    sigset(SIGALRM, setflag);		/* ATM: was after setitimr() */
	    setitimer(ITIMER_REAL, &udt, 0);
	    printf("A miracle!  He's alive!\n");
	}
	timeout.tv_sec=0;
	timeout.tv_usec= 50000;
	readfds=(1<<sock);
	if (select(32, &readfds, 0, 0, &timeout) != 0) {
	    readFromClient();
	}
	if (me->p_updates > delay) {
	    me->p_flags &= ~(PFWAR);
	}
	if (me->p_updates > rdelay) {
	    me->p_flags &= ~(PFREFITTING);
	}
	/* Keep self from being nuked... */
	me->p_ghostbuster = 0;
	if (sendflag) {
	    intrupt();
	    sendflag=0;
	}
    }
}
