/*
 * startdaemon.c
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

startdaemon()
{
    int i;

    i = fork();
    if (i == 0) {
	execl(DAEMON, "daemonII (from ntserv)", 0);
	perror(DAEMON);
	fprintf(stderr, "Couldn't start daemon!!!\n");
	_exit(1);		/* why _exit()?? ++ATM */
    }
    if (i < 0) {		/* ATM */
	perror("ntserv: Unable to fork off the daemon\n");
    }
/*    printf("Daemon process is %d\n", i);*/
}

practice_robo()
{
    char *arg1;
    register int i;
    register struct player *j;

    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	if (j->p_status != PALIVE)
	    continue;
	if (j == me)
	    continue;
	warning("Can't send in practice robot with other players in the game.");
	return;
    }

    if (fork() == 0) {
	(void) sigset(SIGALRM, SIG_DFL);
	(void) close(0);
	(void) close(1);
	(void) close(2);
	switch (me->p_team) {
	    case FED:
		arg1 = "-Tf";
		break;
	    case ROM:
		arg1 = "-Tr";
		break;
	    case KLI:
		arg1 = "-Tk";
		break;
	    case ORI:
		arg1 = "-To";
		break;
	}
	execl(ROBOT, "robot", arg1, "-p", "-f", "-h", 0);
	/* If we get here, we are hosed anyway */
	_exit(1);
    }
}
