/* main.c
 * this is an attempt at an xtrek server starter program
 * to get around the bloody inetd thingy.
 * it works by constantly checking a port(592) to see if someone
 * is trying ton connect to an xtrek server.  If so, it forks
 *  the standard startup routine.  
 *  I.e., if you read the docs, this
 * program is a patch so that you don't need inetd.  It does the same
 * thing!
 */
#include <stdio.h>
/*#include <strings.h>*/
#include <string.h>		/* ATM */
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/errno.h>
#include <signal.h>		/* ATM for reaper() */
#include <sys/wait.h>		/* ATM for reaper() */

/*#define STARTPROG "/usr/games/lib/xtrekII/xtrekII.sock"*/
#define STARTPROG "/usr/local/games/lib/netrek/xtrekII.sock"
#define LOGFILE		"/usr/local/games/lib/netrek/startdlog" /* ATM */

int sock = -1;
int newsock = -1;
int port = 2592; /* normal xtrek is 592, but unix won't let us bind that! */
extern int errno;
int connectionAttemptDetected();
FILE *startdlog;

main(argc, argv)
int argc;
char **argv;
{
	int tries=0;
	int forked;
	char startprog[255];
	char sockstr[10];
	int reaper();

        if(argc == 2){
		port = atoi(argv[1]);
	}
	printf("Preparing to accept xtrek calls to port %d...\n", port);

	(void) signal(SIGHUP, SIG_IGN);		/* ATM */
	(void) signal(SIGCHLD, reaper);		/* ATM */

	if ((startdlog = fopen(LOGFILE, "a")) == NULL)
	    perror("can't open startdlog");

keepontrying:
	while(!connectionAttemptDetected()){
	    fprintf(stderr, "Whoops.  Bye.\n");
	    exit(0);
	}

	if (!fork()) {
	    execl(STARTPROG, 0);
	    printf("Error in execve! -- \n");
	    reporterror();
	}
	close(0);

	goto keepontrying;
}


int connectionAttemptDetected()
{
    struct sockaddr_in addr;
    struct sockaddr_in naddr;
    struct timeval timeout;
    int readfds;
    int len;

restart:

    if(sock < 0){
	if((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0 ){
		printf("Hey! I can't make a socket!\n");
		printf("I'll try again \n");
		return(0);
	}
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = INADDR_ANY;
	addr.sin_port = htons(port);
	
	if(bind(sock, &addr, sizeof(addr)) < 0){
	    if(errno == ENOTSOCK){
		    printf("bogus! socket is unbindable!\n");
		    printf("Used Port %d \n", port);
		    reporterror();
		    close(sock);
		    sock = -1;
		    sleep(10);
		    printf("closing socket!");
		    return(0);
	    }
	    sleep(10);
	    if (bind(sock, &addr, sizeof(addr)) < 0) {
		sleep(10);
		if (bind(sock, &addr, sizeof(addr)) < 0) {
		    printf("Bogus! I can't bind to the socket!\n");
		    printf("Error: %d\n", errno);
		    printf("(is startd already running?\n");
		    close(sock);
		    return(0);
		}
	    }
	}
	listen(sock, 5);
	close(0);
    }
    printf("Bind successful; listening to port %d\n", port);
	
    len = sizeof(naddr);
    while ((newsock = accept(sock, &naddr, &len)) < 0 && (errno == EINTR))
	;

    if(newsock < 0){
	 printf("accept error!");
	 reporterror();
	 printf("Noone calling!\n");
	 shutdown(sock, 2);
	 close(sock);
	 sock = -1;
	 return(0);
    } else {
	 if (newsock != 0) {
	     if (dup2(newsock, 0) == -1) {
		 fprintf(stderr, "failed dup2\n");
		 reporterror();
	     }
	     close(newsock);
	 }
	 return(1);
    }
}


reporterror()
{
    switch(errno){
  	    case EBADF:
		printf("EBADF!\n");
		break;
  	    case ENOTSOCK:
		printf("ENOTSOCK!\n");
		break;
  	    case EOPNOTSUPP:
		printf("EOPNOTSUPP!\n");
		break;
  	    case EFAULT:
		printf("EFAULT!\n");
		break;
  	    case EWOULDBLOCK:
		printf("EWOULDBLOCK!\n");
		break;
	    case ENOTDIR:
		printf("ENOTDIR!\n");
		break;
	    case EINVAL:
		printf("EEINVAL!\n");
		break;
	    case ENOENT:
		printf("ENOENT!\n");
		break;
	    case ELOOP:
		printf("ELOOP!\n");
		break;
	    case EACCES:
		printf("EACCES!\n");
		break;
	    case ENOEXEC:
		printf("ENOEXEC!\n");
		break;
	    case ENOMEM:
		printf("ENOMEM!\n");
		break;
	    case EADDRNOTAVAIL:
		printf("EADDRNOTAVAIL!\n");
		break;
	    case EADDRINUSE:
		printf("EADDRINUSE!\n");
		break;
	    case EINTR:
		printf("EINTR! (this should be fixed)\n");
		break;
	    default:
		printf("BOGUS!!\n");
    }
}

reaper(sig)		/* ATM */
{
    int id;
    union wait status;

    (void) signal(sig, SIG_IGN);
    while ((id = wait3(&status, WNOHANG, (struct rusage *) 0)) > 0) {
	if (startdlog != NULL) {
	    fprintf(startdlog, "Reaped process #%d: ", id);
	    fprintf(startdlog, "w_status=%d, w_termsig=%d, w_retcode=%d\n",
		status.w_status, status.w_termsig, status.w_retcode);
	}
    }
    if (startdlog != NULL) {
	fprintf(startdlog, "Done reaping (id=%d, errno=%d)\n", id, errno);
	fflush(startdlog);
    }
    signal(sig, reaper);
}

